"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __async = (__this, __arguments, generator) => {
  return new Promise((resolve, reject) => {
    var fulfilled = (value) => {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    };
    var rejected = (value) => {
      try {
        step(generator.throw(value));
      } catch (e) {
        reject(e);
      }
    };
    var step = (x) => x.done ? resolve(x.value) : Promise.resolve(x.value).then(fulfilled, rejected);
    step((generator = generator.apply(__this, __arguments)).next());
  });
};

// src/client/index.ts
var client_exports = {};
__export(client_exports, {
  signIn: () => signIn,
  signOut: () => signOut
});
module.exports = __toCommonJS(client_exports);

// src/client/callbacks/signin.ts
var import_axios = __toESM(require("axios"));
function signIn(provider, config) {
  return __async(this, null, function* () {
    var _a;
    const { data: oauthUrlJson } = yield import_axios.default.get("/api/auth/signIn", {
      params: {
        provider
      },
      headers: __spreadValues({}, config),
      validateStatus: () => true
    });
    if (typeof window == "undefined")
      throw Error("signin should be ran client side");
    if (!oauthUrlJson.success) {
      return oauthUrlJson;
    } else if ((_a = oauthUrlJson.data) == null ? void 0 : _a.url) {
      window.location.href = oauthUrlJson.data.url;
      return false;
    } else {
      return oauthUrlJson;
    }
  });
}

// src/client/callbacks/signout.ts
function signOut() {
  return __async(this, null, function* () {
    yield fetch(`/api/auth/signOut`);
    if (typeof window !== "undefined") {
      window.location.reload();
    } else {
      throw new Error("This function can only be used on the client-side.");
    }
  });
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  signIn,
  signOut
});
